/* tde94r.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

int main(void)
{
    /* Builtin functions */
    double exp(double), cos(double), sin(double);

    /* Local variables */
    extern int de94r_c(U_fp, U_fp, U_fp, int *, int *, float *, float *,
                       float *, float *, float *, float *, logical *,
                       float *, float *, float *, float *, float *,
                       float *, float *, float *, float *, float *,
                       float *, int *);
    static float hmin;
    static int ierr;
    static float a[16] /* was [4][4] */;
    extern int f_c();
    static float h__;
    static int m;
    static float p, x, a1[16] /* was [4][4] */,
                       a2[16] /* was [4][4] */,
                 r1[4], r2[4], r3[4], r4[4], y1, y2, y3, y4;
    extern int fj_c();
    static int ih;
    static float yd[4];
    extern int fx_c();
    static float xp, yp[4], yx[4];
    static int jstart;
    static float rab[20];
    static logical bul;
    static float eps;

    m = 4;
    x = 0.f;
    yx[0] = 10.f;
    yx[1] = 11.f;
    yx[2] = 111.f;
    yx[3] = 111.f;
    hmin = 1e-10f;
    eps = 1e-4f;
    p = 1e3f;
    jstart = 0;
    h__ = .01f;
    ih = 0;
L100:
    ++ih;
    de94r_c((U_fp)f_c, (U_fp)fj_c, (U_fp)fx_c, &m, &jstart, &hmin, &eps, &p,
            yx, &x, &h__, &bul, &xp, yp, a, a1, a2, rab, r1, r2, r3, r4, yd,
            &ierr);

/*   BCEHE TOHOO PEEH CCTEM: */
    y1 = (float)exp(x * -100.f) * 10.f;
    y2 = y1 + (float)exp(-x) * ((float)cos(x) + (float)sin(x));
    y3 = y2 + (float)exp(x * -1e4f) * 100.f *
         (float)cos(x * 10.f);
    y4 = y3 + (float)exp(x * -1e4f) * 100.f *
         (float)sin(x * 10.f);

    printf("\n %16.7e %16.7e ", y1, y2);
    printf("\n %16.7e %16.7e \n", y3, y4);
    printf("\n %16.7e %16.7e ", yx[0], yx[1]);
    printf("\n %16.7e %16.7e \n", yx[2], yx[3]);
    printf("\n %16.7e \n", x);
    printf("\n %16.7e \n", h__);
/* PACEATKA OPEHOCT PEHHOO PEEH */
    printf("\n %16.7e %16.7e ", rab[0], rab[1]);
    printf("\n %16.7e %16.7e \n\n", rab[2], rab[3]);
    switch (ih) {
        case 1:  goto L101;
        case 2:  goto L102;
        case 3:  goto L103;
        case 4:  goto L104;
        case 5:  goto L105;
        case 6:  goto L106;
    }
L101:
    h__ = 1e-8f;
    goto L100;
L102:
    h__ = -1e-8f;
    goto L100;
L103:
    jstart = -1;
    goto L100;
L104:
    jstart = -1;
    h__ = -1e-8f;
    goto L100;
L105:
    h__ = .01f;
    goto L100;
L106:
    return 0;
} /* main */

int f_c(float *x, float *y, float *dy, int *m)
{
    /* Builtin functions */
    double exp(double), cos(double);

    /* Local variables */
    static float t1;

    /* Parameter adjustments */
    --dy;
    --y;

    /* Function Body */
    dy[1] = y[1] * -100.f;
    t1 = (float)exp(*x * -100.f) * 20.f +
         (float)exp(-(*x)) * 2.f * (float)cos(*x);
    dy[2] = dy[1] - y[2] * 2.f + t1;
    dy[3] = dy[1] + y[2] * 9998.f - y[3] * 9990.f - y[4] * 10.f + t1;
    dy[4] = dy[1] + y[2] * 9988.f + y[3] * 20.f - y[4] * 10010.f + t1;
    return 0;
} /* f_c */

int fj_c(float *x, float *y, float *df, int *m)
{
#define df_ref(a_1,a_2) df[(a_2)*4 + a_1]

    /* Parameter adjustments */
    df -= 5;
    --y;

    /* Function Body */
    df_ref(1, 1) = -100.f;
    df_ref(1, 2) = 0.f;
    df_ref(1, 3) = 0.f;
    df_ref(1, 4) = 0.f;
    df_ref(2, 1) = -100.f;
    df_ref(2, 2) = -2.f;
    df_ref(2, 3) = 0.f;
    df_ref(2, 4) = 0.f;
    df_ref(3, 1) = -100.f;
    df_ref(3, 2) = 9998.f;
    df_ref(3, 3) = -9990.f;
    df_ref(3, 4) = -10.f;
    df_ref(4, 1) = -100.f;
    df_ref(4, 2) = 9988.f;
    df_ref(4, 3) = 20.f;
    df_ref(4, 4) = -10010.f;
    return 0;
} /* fj_c */

#undef df_ref

int fx_c(float *x, float *y, float *dx, int *m)
{
    /* Builtin functions */
    double exp(double), cos(double), sin(double);

    /* Parameter adjustments */
    --dx;
    --y;

    /* Function Body */
    dx[1] = 0.f;
    dx[2] = (float)exp(*x * -100.f) * -2e3f -
            (float)exp(-(*x)) * 2.f * ((float)cos(*x) +
            (float)sin(*x));
    dx[3] = dx[2];
    dx[4] = dx[2];
    return 0;
} /* fx_c */
